import { Injectable } from '@angular/core';
import { HttpClient } from '@angular/common/http';
import { Observable } from 'rxjs';

import { SERVER_API_URL } from 'app/app.constants';

export class DeploymentInfo {
  branch = '';
  commitId = '';
}
@Injectable({ providedIn: 'root' })
export class ApplicationInfoService {
  cachedDeploymentInfo: DeploymentInfo;
  inLoading = false;
  constructor(private http: HttpClient) {
    this.cachedDeploymentInfo = {} as DeploymentInfo;
  }

  private loadDeploymentInfo(): Observable<DeploymentInfo> {
    return this.http.get<DeploymentInfo>(SERVER_API_URL + 'api/applicationInfo/deploymentInfo');
  }

  public getDeploymentInfo(): DeploymentInfo {
    if (!this.cachedDeploymentInfo.branch && !this.inLoading) {
      this.inLoading = true;
      this.loadDeploymentInfo().subscribe(res => {
        this.cachedDeploymentInfo = res;
        this.inLoading = false;
      });
    }
    return this.cachedDeploymentInfo;
  }
}
